:- module(costabs_settings,[costabs_path/1, abspath/1,abs_frontend/1]).

:- use_module(stdlib(utils),[ut_member/2,ut_split_path/2]).
:- use_module(stdlib(shell_utilities),[get_env_atom/2]).

costabs_path(P) :-
	get_env_atom('COSTABSHOME',P),
	!.

costabs_path(P) :-
	get_env_atom('HOME',HomePath),
	atom_concat(HomePath,'/Systems/costa/costabs/',P),
	!.


abspath(AbsPath) :-
	get_env_atom('ABSPATH',P),
	atom_codes(P,PCodes),
	ut_split_path(PCodes,ABSPATHs),
	!,
	ut_member(AbsPath,ABSPATHs).

abs_frontend(CP) :-
	costabs_path(P),
	atom_concat(P,'/lib/absfrontend.jar',CP).
