#!/bin/bash

costabs=$HOME/Systems/costa/costabs;
plrc=$HOME/.plrc;

echo -e \\tInstalling COSTABS from SWI Prolog;

#plrc

echo "";
echo -e \\tConfiguring $plrc;

if ! [ -e $plrc ]; then
	echo -e \\tCreating $plrc;
	if ( ! touch $plrc ) ; then
		echo -e \\t*Fatal error;
		exit;
	fi
fi

echo "";
echo -e \\tReading $plrc;
grep start:costabs $plrc > /dev/null 2> /dev/null;
i=$?;
if [ $i == 0 ]; then
	echo -e \\t$plrc was already configured;
elif [ $i == 1 ]; then
	echo -e \\tConfiguring $plrc;	
	echo -e "%% start:costabs
%%
:- include('$HOME/Systems/costa/costabs/config/costabs_swi_search_paths').
:- set_prolog_flag(encoding,octet).
%%
%% end:costabs" >> $plrc;
else
	echo -e \\t*Fatal error.
fi

# /config/costabs_swi_search_paths.pl

echo "";
paths=$costabs/config/costabs_swi_search_paths.pl;
echo -e \\tReading $paths;
grep "^home_dir\(.*\)" $paths > /dev/null 2> /dev/null; 
i=$?;

if [ $i == 0 ]; then
	echo -e \\t$paths was already configured;
else
	rm $paths;
	echo -e \\tConfiguring $paths; 
	echo -e "\nfile_search_path(costabs,'$HOME/Systems/costa/costabs/src')." >> $paths;
	echo -e "\nfile_search_path(costabs,'$HOME/Systems/costa/costabs/src/interfaces/shell')." >> $paths;		
fi

