package costabs.console;

import java.io.OutputStream;

import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleManager;
import org.eclipse.ui.console.MessageConsole;
import org.eclipse.ui.console.MessageConsoleStream;

public class ConsoleHandler {

	

		public static final String ID_CONSOLE_VIEW = "CostabsConsole";

		private static MessageConsole findPetConsole() {
		      ConsolePlugin plugin = ConsolePlugin.getDefault();
		      IConsoleManager conMan = plugin.getConsoleManager();
		      IConsole[] existing = conMan.getConsoles();
		      for (int i = 0; i < existing.length; i++)
		         if (ID_CONSOLE_VIEW.equals(existing[i].getName()))
		            return (MessageConsole) existing[i];
		      //no console found, so create a new one
		      MessageConsole myConsole = new MessageConsole(ID_CONSOLE_VIEW, null);
		      conMan.addConsoles(new IConsole[]{myConsole});
		      return myConsole;
		   }

		/**
		 * Returns the Pet Console Output Stream to write to the console.
		 * @return Pet Console Output Stream to write to the console.
		 */
		public static OutputStream getCostaConsoleStream () {
			MessageConsole myConsole = findPetConsole();
			MessageConsoleStream out = myConsole.newMessageStream();
			return out;
		}

		public static void write(String text) {
			
			MessageConsole myConsole = findPetConsole();
			MessageConsoleStream out = myConsole.newMessageStream();
			out.println(text);
		}
	
		public static void clearConsole() {
			MessageConsole myConsole = findPetConsole();
			myConsole.clearConsole();
		}
}
