package costabs.dialogs;


import java.util.ArrayList;


import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.preference.IPreferenceNode;
import org.eclipse.jface.preference.IPreferencePage;
import org.eclipse.jface.preference.PreferenceDialog;
import org.eclipse.jface.preference.PreferenceManager;
import org.eclipse.jface.preference.PreferenceNode;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import costabs.console.ConsoleHandler;
import costabs.preferences.CostabsPreferences;

public class MethodDialog extends Dialog {

	private ArrayList<String> absMethods;
	
	private ArrayList<String> absFunctions;
	
	private ArrayList<String> selectedItems;
	
	private Button[] methodsSelection;
	
	private Button[] functionsSelection;
	
	private boolean editPreferences = false;
	
	private boolean usingStd = false;
	
	public MethodDialog(Shell parentShell, ArrayList<String> absMethods, ArrayList<String> absF, boolean std) {
		super(parentShell);
		this.absMethods = absMethods;
		absFunctions = absF;
		usingStd = std;
	}
	
	protected Control createDialogArea(Composite parent) {
		
		
		Composite composite = (Composite)super.createDialogArea(parent);		

		try {
			
			//selectionsForm = new Button [this.absMethods.size()+this.absFunctions.size()];
			methodsSelection = new Button[this.absMethods.size()];
			functionsSelection = new Button[this.absFunctions.size()];

			GridLayout layout = new GridLayout(6, false);
			composite.setLayout(layout);
			
			Button b = new Button(composite, SWT.CHECK);
			b.setText("Select all");
			b.addSelectionListener(new SelectAllChangeListener (this, b));
			
			Button bFunctions = new Button(composite, SWT.CHECK);
			bFunctions.setText("Select all functions");
			bFunctions.addSelectionListener(new SelectFunctionsChangeListener (this, bFunctions));
			
			Button bMethods = new Button(composite, SWT.CHECK);
			bMethods.setText("Select all methods");
			bMethods.addSelectionListener(new SelectMethodsChangeListener (this, bMethods));
			
			for (int i = 0; i < 3; i++) {
				Label labelEmpty = new Label (composite, SWT.NULL);
				labelEmpty.setText("");
			}

			Label label = new Label (composite, SWT.NULL);
			if (usingStd)
				label.setText("Functions (including those in stdlib):");
			else 
				label.setText("Functions:");
			
			for (int i = 0; i < 2; i++) {
				Label labelEmpty = new Label (composite, SWT.NULL);
				labelEmpty.setText("");
			}
			
			Label labelMethods = new Label (composite, SWT.NULL);
			labelMethods.setText("Methods:");
			
			for (int i = 0; i < 2; i++) {
				Label labelEmpty = new Label (composite, SWT.NULL);
				labelEmpty.setText("");
			}
			
			int higherSize = 0;
			if (absFunctions.size() > absMethods.size()) higherSize = absFunctions.size();
			else higherSize = absMethods.size();

			int k = 0;
			int i = 0;
			while (i < higherSize) {
				
				
					if (i < absFunctions.size()) {
						this.functionsSelection [i] = new Button(composite, SWT.CHECK);
						
						this.functionsSelection [i].setText(this.absFunctions.get(i));
						this.functionsSelection [i].setSelection(false);
						k++;
						
						if (i + 1 < absFunctions.size()) {
							this.functionsSelection [i +1] = new Button(composite, SWT.CHECK);
							
							this.functionsSelection [i +1].setText(this.absFunctions.get(i + 1));
							this.functionsSelection [i +1].setSelection(false);
							k++;
							if (i + 2 < absFunctions.size()) {
								this.functionsSelection [i +2] = new Button(composite, SWT.CHECK);
								
								this.functionsSelection [i +2].setText(this.absFunctions.get(i + 2));
								this.functionsSelection [i +2].setSelection(false);
								k++;
							}
							else {
								Label labelEmpty = new Label (composite, SWT.NULL);
								labelEmpty.setText("");
							}
						}
						else {
							Label labelEmpty = new Label (composite, SWT.NULL);
							labelEmpty.setText("");
							Label labelEmpty2 = new Label (composite, SWT.NULL);
							labelEmpty2.setText("");
						}
					}
					else {
						Label labelEmpty = new Label (composite, SWT.NULL);
						labelEmpty.setText("");
						Label labelEmpty2 = new Label (composite, SWT.NULL);
						labelEmpty2.setText("");
						Label labelEmpty3 = new Label (composite, SWT.NULL);
						labelEmpty3.setText("");
					}
					
					if (i < absMethods.size()) { 
						this.methodsSelection [i] = new Button(composite, SWT.CHECK);
						
						this.methodsSelection [i].setText(this.absMethods.get(i));
						this.methodsSelection [i].setSelection(false);
						k++;
						
						if (i + 1 < absMethods.size()) { 
							this.methodsSelection [i + 1] = new Button(composite, SWT.CHECK);
							
							this.methodsSelection [i + 1].setText(this.absMethods.get(i + 1));
							this.methodsSelection [i + 1].setSelection(false);
							k++;
							if (i + 2< absMethods.size()) { 
								this.methodsSelection [i + 2] = new Button(composite, SWT.CHECK);
								
								this.methodsSelection [i + 2].setText(this.absMethods.get(i + 2));
								this.methodsSelection [i + 2].setSelection(false);
								k++;
								
							}
							else {
								Label labelEmpty = new Label (composite, SWT.NULL);
								labelEmpty.setText("");
							}
							
						}
						else {
							Label labelEmpty = new Label (composite, SWT.NULL);
							labelEmpty.setText("");
							Label labelEmpty2 = new Label (composite, SWT.NULL);
							labelEmpty2.setText("");
						}
						
					}
					else {
						Label labelEmpty = new Label (composite, SWT.NULL);
						labelEmpty.setText("");
						Label labelEmpty2 = new Label (composite, SWT.NULL);
						labelEmpty2.setText("");
						Label labelEmpty3 = new Label (composite, SWT.NULL);
						labelEmpty3.setText("");
					}

				i = i + 3;
			}
			
			
		}
		catch (Exception e) {
			ConsoleHandler.write("Error creating Methods / functions Dialog ");

		}
		
		return composite;
	}
	
	@Override
	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText("Select the functions and/or methods to be analyzed");
	}

	@Override
	protected void okPressed() {

		selectedItems = new ArrayList<String> ();

		boolean selected = false;

		int k = 0;
		int i = 0;
		while ((i < functionsSelection.length) || (i < methodsSelection.length)) {
			if (i < absFunctions.size()) {
				if (this.functionsSelection[i].getSelection()) {
					selected = true;
					selectedItems.add(this.absFunctions.get(i));
				}
			}
			if (i < absMethods.size()) {
				if (this.methodsSelection[i].getSelection()) {
					selected = true;
					selectedItems.add(this.absMethods.get(i));
				}
			}
			
			i++;
		}

		if (!selected && !this.editPreferences) {
			MessageDialog.openInformation(
					getShell(),
					"Problem",
			"Al least one method must be selected");
			return;
		}

		if (this.editPreferences) {
			IPreferencePage page = new CostabsPreferences();
			page.setTitle("General");
			PreferenceManager mgr = new PreferenceManager();
			IPreferenceNode node = new PreferenceNode("1", page);
			mgr.addToRoot(node);
			PreferenceDialog dialog = new PreferenceDialog(getShell(), mgr);
			dialog.create();
			dialog.setMessage("Please, set the preferences for the analysis");
			dialog.open();
			this.editPreferences = false;
			return;
		}
		
		methodsSelection = null;
		functionsSelection = null;
		
		this.close();
	}
	
	public ArrayList<String> getSelectedMethods() {
		return this.selectedItems;
	}
	
	@Override
	protected void createButtonsForButtonBar(Composite parent) {
		GridLayout layout = new GridLayout (1,true);
		parent.setLayout(layout);
		parent.pack();
		Button ok = new Button(parent, SWT.PUSH);
		ok.setText("Edit Preferences");
		GridData data = new GridData(GridData.CENTER);
		ok.setLayoutData(data);
		ok.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent event) {
				editPreferences = true;
				okPressed();
			}
		});
		super.createButtonsForButtonBar(parent);
		this.getButton(IDialogConstants.OK_ID).setText("Analyze");
	}
	
	protected Button [] getSelectionMethods () {
		return this.methodsSelection;
	}
	
	protected Button [] getSelectionFunctions () {
		return this.functionsSelection;
	}
	
}

class SelectAllChangeListener implements SelectionListener {

	MethodDialog dialog = null;
	Button b;

	public SelectAllChangeListener(MethodDialog dialog, Button b) {
		this.dialog = dialog;
		this.b = b;
	}

	public void widgetDefaultSelected(SelectionEvent e) {
	}

	public void widgetSelected(SelectionEvent e) {
		boolean selected = b.getSelection();
		for (int i = 0; i < this.dialog.getSelectionMethods().length; i++) {
			this.dialog.getSelectionMethods()[i].setSelection(selected);
		}
		for (int i = 0; i < this.dialog.getSelectionFunctions().length; i++) {
			this.dialog.getSelectionFunctions()[i].setSelection(selected);
		}
	}

}

class SelectMethodsChangeListener implements SelectionListener {

	MethodDialog dialog = null;
	Button b;

	public SelectMethodsChangeListener(MethodDialog dialog, Button b) {
		this.dialog = dialog;
		this.b = b;
	}

	public void widgetDefaultSelected(SelectionEvent e) {
	}

	public void widgetSelected(SelectionEvent e) {
		boolean selected = b.getSelection();
		for (int i = 0; i < this.dialog.getSelectionMethods().length; i++) {
			this.dialog.getSelectionMethods()[i].setSelection(selected);
		}
	}

}

class SelectFunctionsChangeListener implements SelectionListener {

	MethodDialog dialog = null;
	Button b;

	public SelectFunctionsChangeListener(MethodDialog dialog, Button b) {
		this.dialog = dialog;
		this.b = b;
	}

	public void widgetDefaultSelected(SelectionEvent e) {
	}

	public void widgetSelected(SelectionEvent e) {
		boolean selected = b.getSelection();
		for (int i = 0; i < this.dialog.getSelectionFunctions().length; i++) {
			this.dialog.getSelectionFunctions()[i].setSelection(selected);
		}
	}

}
