
:- module(config_shell,[main_config/1]).

:- use_module(stdlib(stdlib_install_common)).
:- use_module(stdlib(stdlib_install_paths)).
:- use_module(stdlib(stdlib_install_options)).
:- use_module(stdlib(shell_utilities)).
:- use_module(stdlib(io_utilities)).

:- use_module(stdlib(utils)).

% ------------------------------------------------------------------------------
% COSTABS INSTALL PROGRAM
%
main_config(_) :-
	set_home,
	shell_config, !.

% ------------------------------------------------------------------------------
% CONFIGURING THE SHELL
%

shell_config :-
	format('Configuring the shell... ',[]),
	get_home(Home),
	ut_atom_concat(Home,'Systems/costa/costabs/',Root),
	ut_atom_concat(Home,'.bashrc',BASHRC),
	format('  Updating or creating ~p... ',BASHRC),
	ut_atoms_concat(['if [ -n "${PATH:+x}" ]; then\n  export PATH=${PATH}:',Root,'src/interfaces/shell\nelse\n  export PATH=',Root,'src/interfaces/shell\nfi'],Line2),
	std_replace_in_file(BASHRC,
	'## start:costabs',
	'## end:costabs',
	['## start:costabs','##',Line2,'##','## end:costabs']),
	done1,
	ut_atom_concat(Home,'.cshrc',CSHRC),
	format('\n  Updating or creating ~p... ',CSHRC),
	ut_atoms_concat(['if ( $?PATH ) then\n  setenv PATH ${PATH}:',Root,'src/interfaces/shell\nelse\n  setenv PATH ',Root,'src/interfaces/shell\nendif'],Line1),
	std_replace_in_file(CSHRC,
	'## start:costabs',
	'## end:costabs',
	['## start:costabs','##',Line1,'##','## end:costabs']),
	 done1, !,
	done.

